#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sat May  9 19:00:59 2020

@author: mario
"""

import networkx as nx
import matplotlib.pyplot as plt

# G is supposed to be a undirected networx.Graph
def make_closure(G, k):
    G_prime = nx.Graph(G)
    for v in G.nodes:
        neighbors = set(G.neighbors(v))
        for i in range(k-1):
            neighbors.update([w for n in neighbors for w in G.neighbors(n)])
        
        G_prime.add_edges_from((v,n) for n in neighbors)
    
    return G_prime


if __name__ == '__main__':
    G = nx.Graph()
    G.add_nodes_from(range(10))
    G.add_edges_from((i,i+1) for i in range(9))
    
    G_prime = make_closure(G,10)
    nx.draw(G_prime)
    plt.show()
